/*
 * Ejercicio3.java
 *
 * Creado el 12 de marzo de 2006, 12:50
 */


package metodosLineales.practica5;
import auxiliar.*;

/**
 * A diferencia de lo que ocurra en el ejercicio 3 de la prctica anterior
 * con el mtodo de Gauss podemos calcular determinantes e inversas de 
 * matrices grandes sin problema.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio1 {
    
    public static void main(String[] args) {
        double[][] A;
        double det;
                
        for (int n = 2; n <= 20; n++) {
            System.out.println("");
            A = new double[n][n];
            for (int k = 0; k < n - 1; k++) {
                A[k][k + 1] = 1;
                A[k + 1][k] = 1;
            }
            try {
                det = Matrices.determinanteGauss(A);
                System.out.println("Determinante de A_"
                        + n + ": " + det);
                System.out.println("Inversa de A_"
                        + n + ":");
                System.out.println(Matrices.toString(Matrices.inversa(A)));  
                System.out.println("Producto de A_"
                        + n + " por su inversa:");
                System.out.println(Matrices.toString(
                        Matrices.producto(A, Matrices.inversa(A)))
                        );  
            } catch(Matrices.ErrorMetodosLineales errMetodosLineales) {
            }            
        }
    }
    
}

