/*
 * Ejercicio5.java
 *
 * Creado el 2 de marzo de 2007, 21:09
 */


package metodosLineales.practica8;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio5 {
    
    public static void main(String[] args) {
        double[][] A = {{2, - 1, 0, 0}, {- 1, 2, - 1, 0}, {0, - 1, 2, - 1}, 
                {0, 0, - 1, 2}};       
        double[][] B = {{1, -1, 3, 4}, {-1, 4, 0, -1}, {3, 0, 0, -3}, {4, -1, -3, 1}};               
        double[][] SolA = new double[4][5];
        double[][] SolB = new double[4][5];
        double[] v = new double[4];
        double lambda;

        try {
            System.out.println();
            System.out.println("Matriz A:");
            System.out.println(Matrices.toString(A));            
            SolA = Matrices.jacobiPropios(A, 1E-5, 100);  
            for(int i = 0; i < 4; i++) {
                for(int j = 0; j < 4; j++) {
                    v[j] = SolA[i][j];
                }  
                lambda = SolA[i][4];
                System.out.println("Vector propio v_" + (i + 1) + ":" );
                System.out.println(Matrices.toString(v));
                System.out.println("Valor propio lambda_" + (i + 1) + ":" );
                System.out.println(lambda);
                System.out.println("Vector Av_" + (i + 1) + " " 
                        + "- lambda_" + (i + 1) + "v_" + (i + 1) + ":");                                
                System.out.println(Matrices.toString(
                        Matrices.resta(Matrices.producto(A, v), 
                        Matrices.producto(lambda, v))) );
            }
        } catch(Matrices.ErrorMetodosLineales err) {
        }
        
        try {
            System.out.println();
            System.out.println("Matriz B:");
            System.out.println(Matrices.toString(B));            
            SolB = Matrices.jacobiPropios(B, 1E-5, 100);            
            for(int i = 0; i < 4; i++) {
                for(int j = 0; j < 4; j++) {
                    v[j] = SolB[i][j];
                }  
                lambda = SolB[i][4];
                System.out.println("Vector propio v_" + (i + 1) + ":" );
                System.out.println(Matrices.toString(v));
                System.out.println("Valor propio lambda_" + (i + 1) + ":" );
                System.out.println(lambda);
                System.out.println("Vector Bv_" + (i + 1) + " " 
                        + "- lambda_" + (i + 1) + "v_" + (i + 1) + ":");                                
                System.out.println(Matrices.toString(
                        Matrices.resta(Matrices.producto(B, v), 
                        Matrices.producto(lambda, v))) );                                    
            }
            System.out.println("Como la matriz formada por los vectores " 
                    + "v_1, v_2, v_3 y v_4 es ortogonal y hemos comprobado ");
            System.out.println("que son vectores propios, formarn una " 
                    + "base de vectores propios (aunque a priori no tenemos ");
            System.out.println("un teorema de convergencia que lo asegure " 
                    + "porque los valores propios estn repetidos).");
            System.out.println();
        } catch(Matrices.ErrorMetodosLineales err) {
        }        
        
    }
    
}
