/*
 * Ejercicio7.java
 *
 * Creado el 28 de junio de 2007, 13:36
 */


package metodosLineales.practica8;
import auxiliar.*;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio7 {
    
    public static void main(String[] args) {
         double[][] A = {{1, 1, 1, 1}, {1, 2, 1, 1}, {1, 1, 3, 1}, {1, 1, 1, 4}};
         double[][] Sol = new double[4][5];
         double[] solpotencia;
         double[] u = new double[4];
         double[] v = {1, 0, 0, 0};
         double[] y = {1, 0, 0, 0};
         double lambda = 0;
         double lambda0 = 3;
         
         /**
          * Como A es simtrica, podemos calcular sus valores y vectores
          * propios por el mtodo de Jacobi:
          */
         try {
             System.out.println();
             System.out.println("Aplicamos el mtodo de Jacobi:");
             System.out.println();
             Sol = Matrices.jacobiPropios(A, 1E-10, 100);
             for(int i = 0; i < 4; i++) {
                 for(int j = 0; j < 4; j++) {
                     u[j] = Sol[i][j];
                 }
                 lambda = Sol[i][4];
                 System.out.println("Vector propio v_" + (i + 1) + ":" );
                 System.out.println(Matrices.toString(u));
                 System.out.println("Valor propio lambda_" + (i + 1) + ":" );
                 System.out.println(lambda);
             }
             System.out.println("Por tanto, el valor propio ms cercano a "
                     + "lambda_0 = 3 es lambda_ 4 = " + lambda); 
             System.out.println("con vector propio v_4 = "
                     + Matrices.toString(u));
             System.out.println();
             System.out.println("Aplicamos el mtodo potenciaMasProxima:");
             System.out.println();
             solpotencia = Matrices.potenciaMasProxima
                     (A, 1E-10, 100, v, y, lambda0);
             for (int i = 0; i < 4; i++) {
                 u[i] = solpotencia[i];
             }
             lambda = solpotencia[4];
             System.out.println("De acuerdo con el mtodo potenciaMasProxima "
                     + "el valor propio ms cercano a lambda_0 = 3 es lambda = " 
                     + lambda);
             System.out.println("con vector propio v = " + Matrices.toString(u));
         } catch(Matrices.ErrorMetodosLineales err) {
         }
    }
    
}
